#!rebol -cs

REBOL []

; --------------------------------
; -- LOADING DATA AND FUNCTIONS --
; --------------------------------

do load %functions.r
do load %configuration.r


; ------------------------
; -- PROCESSING COMMENT --
; ------------------------

cgi-input: make object! decode-cgi system/options/cgi/query-string
commentsreference: cgi-input/commentsreference

now-digits: time-in-digits now
if error? try [this-comment: make-comment cgi-input now-digits][ignore: copy []]
if error? try [save-comment-object: reform ["save" rejoin [{%} unapproved-comments-folder commentsreference {/} now-digits {.r}] "this-comment"]][ignore: copy []]
if error? try [do save-comment-object][ignore: copy []]

; ----------------------------
; -- GATHERING ARTICLE INFO --
; ----------------------------

read-article: reform ["article-content: do load" rejoin [{%} approved-article-folder commentsreference {.r}] ]
do read-article
article-temp: make article-content []

; --------------------------------
; -- GATHER AND DISPLAY ARTICLE --
; --------------------------------

print "Content-Type: text/html^/"

print rejoin [	{<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">} newline newline
				{<HTML>} newline newline
				{<HEAD>} newline newline
				{<TITLE>} page-title {</TITLE>} newline newline
				{<META NAME="Keywords" CONTENT="} meta-keywords {">} newline newline
				{</HEAD>} newline newline
				]

stylesheet: read headline-stylesheet
print rejoin [stylesheet newline newline]

print rejoin [{<BODY>} newline newline]

print rejoin [	{<TABLE width="} page-width {">} newline
				{<TR>} newline
				{<TD>} newline
				]

print rejoin [	{<DIV class="banner">} newline
				{<HR>} newline
				{<font class="banner">} publication-name {</font>} newline
				{<HR>} newline
				{<font class="copyright">} publication-name {<small><SUP>TM</SUP></small> &nbsp &nbsp} copyright-info {</font>} newline
				{<HR>} newline
				{</DIV>} newline newline
				]

print rejoin [	{<TABLE width="} headlines-width {">} newline
				{<TR>} newline
				{<TD>} newline
				]

print rejoin [{<DIV class="article">} newline newline]

print rejoin [	{<P class="headline">}
				{<font class="headline">} article-temp/headline {</font>}
				{<BR>} newline
				]

print rejoin [	{<font class="subheadline">} article-temp/subheadline {</font>}
				{<BR>} newline
				]

print rejoin [{<font class="articlepostdate">} {posted on } article-temp/article-post-date {</font>} newline newline]

print rejoin [	{<P class="byline">}
				{<font class="byline">} article-temp/byline {</font>}
				{<BR>} newline
				]

print rejoin [{<font class="title">} article-temp/title {</font>} newline newline]

pieces: length? article-temp/body

for y 1 pieces 1 [
	piece-path: reform [rejoin ["article-temp/body/" y] ]
	body-piece: load piece-path

	print rejoin [	{<P class="body">}
					{<font class="body">} body-piece {</font>} newline newline
					]
]

print rejoin [	{<P class="referencenumber">}
				{<font class="referencenumber">} {REF: } article-temp/reference-number {</font>}
				{<BR>} newline
				]

print rejoin [{</DIV>} newline newline]


; ---------------------------------
; -- GATHER AND DISPLAY COMMENTS --
; ---------------------------------

read-directory: reform [ "comments-directory: read" rejoin [{%} approved-comments-folder commentsreference {/}] ]
do read-directory

number-of-comments: length? comments-directory

comments-directory: tail comments-directory

file-list: copy []
for file-grab 1 number-of-comments 1 [
	comments-directory: back comments-directory
	file-name: first comments-directory
	append file-list file-name
]

div-style: 0

foreach file-name file-list [
	read-comment: reform ["comment-content: do load" rejoin [{%} approved-comments-folder commentsreference {/} file-name] ]
	do read-comment
	comment-temp: make comment-content []

	div-style: div-style + 1
	either even? div-style [
		print rejoin [{<DIV class="comment2">} newline newline]
		] [
		print rejoin [{<DIV class="comment">} newline newline]
		]

	print rejoin [	{<P class="commentheading">}
					{<font class="commentheading">} comment-temp/heading {</font>}
					{<BR>} newline
					]

	print rejoin [	{<font class="commentauthor">} comment-temp/name {</font>}
					{<BR>} newline
					]

	print rejoin [	{<font class="commentauthoremail">} comment-temp/email {</font>}
					{<BR>} newline
					]

	print rejoin [{<font class="commentpostdate">} {posted on } comment-temp/comment-post-date {</font>} newline newline]


	print rejoin [	{<P class="commentbody">} {<font class="commentbody">} comment-temp/body {</font>} newline newline]

	print rejoin [	{<P class="commentreferencenumber">}
					{<font class="commentreferencenumber">} {REF: } comment-temp/reference-number {</font>}
					{<BR>} newline
					]

	print rejoin [{</DIV>} newline newline]
]

; --------------------------
; -- DISPLAY COMMENT FORM --
; --------------------------

print rejoin [{<FORM METHOD=GET ACTION="http://www.beosjournal.com/cgi-bin/displaycomments.cgi">} newline newline]

print rejoin [{<INPUT TYPE="hidden" name="commentsreference" value="} commentsreference {">} newline newline]

print rejoin [{<P class="commentformheading"><font class="commentformheading">Post your comments here</font>} newline newline]

print rejoin [{<P class="commentformheading"><font class="commentformitem">Heading:</font><BR><INPUT TYPE="text" NAME="heading">} newline newline]

print rejoin [{<P class="commentformheading"><font class="commentformitem">Comments:</font><BR><TEXTAREA NAME="body" ROWS="6" COLS="57"></TEXTAREA>} newline newline]

print rejoin [{<P class="commentformheading"><font class="commentformitem">Your name:</font><BR><INPUT TYPE="text" NAME="name">} newline newline]

print rejoin [{<P class="commentformheading"><font class="commentformitem">E-mail address:</font><BR><INPUT TYPE="text" NAME="email">} newline newline]

print rejoin [{<P class="commentformheading"><INPUT TYPE="submit" VALUE="Submit comments">} newline newline]

print rejoin [{</FORM>} newline newline]
print rejoin [{</TABLE>} newline newline]
print rejoin [{</TABLE>} newline newline]

print rejoin [	{</BODY>} newline newline
		{</HTML>}
		]
